package lifeline.connection;

import java.util.ArrayList;

import org.apache.http.HttpResponse;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

public class Connection {
	//This class is used to handle making HTTP requests to the server
	
	// The server's URL
	static String URL = "http://129.2.147.183:4567";
	
	//sends a POST request to the server and returns the response
	public static HttpResponse postRequest(ArrayList<BasicNameValuePair> params, 
			String path) {
		try {
			DefaultHttpClient client = new DefaultHttpClient();
			HttpPost request = new HttpPost(URL + path);
			request.setEntity(new UrlEncodedFormEntity(params));
			HttpResponse response = client.execute(request);
			return response;
		} catch (Exception e) { e.printStackTrace(); }
		return null;
	}
	
	//sends a GET request to the server and returns the response
	public static HttpResponse getRequest(String path) {
		try {
			DefaultHttpClient client = new DefaultHttpClient();
			HttpGet request = new HttpGet(URL + path);
			HttpResponse response = client.execute(request);
			return response;
		} catch (Exception e) { e.printStackTrace(); }
		return null;
	}

	//method used to test if the server is up and working
	public static String hi() {
		ArrayList<BasicNameValuePair> params = new ArrayList<BasicNameValuePair>();
		params.add(new BasicNameValuePair("Hello","SHALOM"));
		String path = "/hi";
		
		HttpResponse resp = postRequest(params, path);
		if (resp != null) {
			System.out.println("HTTP Response Status: " + resp.getStatusLine());
			System.out.println("RESP: " + resp.getHeaders("Hello")[0]);
			return resp.getHeaders("Hello")[0].toString();
		}
		return null;
	}

}