package lifeline.connection;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;

public class DBHandle {
	private static SQLiteDatabase db;
	private static DatabaseOpenHelper dbHelper;
	private static Context context;
	
	private static void createConnection(Context c) {
		context = c.getApplicationContext();
		dbHelper = new DatabaseOpenHelper(context);
		db = dbHelper.getWritableDatabase();
	}
	
	public static void openConnection(Context c) {
		if (db == null || !db.isOpen())
			createConnection(c);
	}
	
	public static SQLiteDatabase getConnection() {
		return db;
	}
	
	public static void closeConnection() {
		db.close();
	}

	public static Context getContext() {
		return context;
	}
}
