package lifeline.connection;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class DatabaseOpenHelper extends SQLiteOpenHelper {
	final private static String GROUPS_TABLE_CMD = 
		"CREATE TABLE IF NOT EXISTS groups ( " +
		"_id integer primary key autoincrement, " +
		"name varchar not null unique, " +
		"desc varchar, website varchar)";
	final private static String USERS_TABLE_CMD =
		"CREATE TABLE IF NOT EXISTS users ( " +
		"_id integer primary key autoincrement, " +
		"name varchar(45), " +
		"phone varchar(15) not null, " +
		"email varchar(45), " +
		"twitter varchar(45), " +
		"pass varchar(45))";
	final private static String MEMBERSHIPS_TABLE_CMD =
		"CREATE TABLE IF NOT EXISTS memberships ( " +
		"_id integer primary key autoincrement, " +
		"user_id integer, " +
		"group_id integer)";
	final private static String MESSAGES_TABLE_CMD =
		"CREATE TABLE IF NOT EXISTS messages (" +
		"_id integer primary key autoincrement, " +
		"user_id integer, " +
		"text varchar, " +
		"timestamp integer, " +
		"group_id integer)";
	
	final private static String NAME = "lifeline_db";
	final private static Integer VERSION = 1;
	final private Context context;
	
	public DatabaseOpenHelper(Context context) {
		super(context, NAME, null, VERSION);
		this.context = context;
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL(USERS_TABLE_CMD);
		db.execSQL(GROUPS_TABLE_CMD);
		db.execSQL(MESSAGES_TABLE_CMD);
		db.execSQL(MEMBERSHIPS_TABLE_CMD);
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// TODO Auto-generated method stub

	}
	
	void deleteDatabase ( ) {
		context.deleteDatabase(NAME);
	}
}