package lifeline.service;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

// This service runs in the background and updates the local DB with info from
// the server. It uses the Updater class to do the actual updating.
// It does all the work on a different thread, to avoid slowing down the UI thread

public class UpdaterService extends Service {
	private final String TAG = "UpdaterService";
	private boolean started;
	private Thread thread;

	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}

	@Override
	public void onCreate() {	
		super.onCreate();
		Log.i(TAG,"onCreate() entered");
		started = false;
		thread = new Thread(new Updater());
	}

	@Override
	public void onDestroy() {
		Log.i(TAG,"onDestroy() entered");
		thread.stop();
		super.onDestroy();
	}
	
	@Override
	public int onStartCommand(Intent intent, int flags, int startid) {
		Log.i(TAG,"onStartCommand() entered");
		if (!started) {
			started = true;
			thread.start();
		}
		return START_STICKY;
	}
}
