package lifeline.ui;

import lifeline.model.Account;
import lifeline.model.Group;
import lifeline.model.User;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnFocusChangeListener;
import android.widget.Button;
import android.widget.EditText;

public class AddLifeLine extends Activity {

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.addlifeline);
		setEditTexts();
		
		Button addGroupButton = (Button) findViewById(R.id.al_button);
		
		//alert asks if done creating lifelines
		final AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage("Are you finished creating LifeLines?")
		.setCancelable(false)
		.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				Intent homeIntent = new Intent(AddLifeLine.this, Home.class);
				startActivity(homeIntent);
			}
		})
		.setNegativeButton("No", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				clearText((EditText) findViewById(R.id.al_name));
				clearText((EditText) findViewById(R.id.al_desc));
				clearText((EditText) findViewById(R.id.al_web));
				dialog.cancel();
			}
		});
		
		//create a lifeline button
		addGroupButton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				final ProgressDialog dialog = ProgressDialog.show(AddLifeLine.this, "Adding LifeLine","Please Wait ...", true);
				final Handler handler = new Handler() {
					public void handleMessage(Message msg) {
						dialog.dismiss();
						AlertDialog alert = builder.create();
						alert.show();
					}
				};
				Thread p_thread = new Thread() {  
					public void run() {
						final String name = ((EditText) findViewById(R.id.al_name)).getText().toString();
						final String desc = ((EditText) findViewById(R.id.al_desc)).getText().toString();
						final String website = ((EditText)findViewById(R.id.al_web)).getText().toString();

						Group newGroup = new Group(name, desc, website);
						User cur = Account.currUser();
						newGroup.addMember(cur);

						handler.sendEmptyMessage(0);
					}
				};
				p_thread.start();
			}
		});
	}

	private void clearText(EditText et){
		et.setText("");
	}
	
	private void clearText2(EditText et){
		String str = et.getText().toString();
		if (str.equals("Name:") || str.equals("Description:") || str.equals("Website:")){
			et.setText("");
		}
	}

	private void setEditTexts(){
		((EditText) findViewById(R.id.al_name)).setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				clearText2((EditText) findViewById(R.id.al_name));
			}
		});

		((EditText) findViewById(R.id.al_desc)).setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				clearText2((EditText) findViewById(R.id.al_desc));
			}
		});

		((EditText) findViewById(R.id.al_web)).setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				clearText2((EditText) findViewById(R.id.al_web));
			}
		});
	}
}
