package lifeline.ui;

import java.util.ArrayList;

import lifeline.model.Group;
import lifeline.model.User;
import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class Contact extends Activity {
	private Intent intent;
	private Intent intent2;
	private Intent intent3;
	private ListView lv;
	private User u = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.contacts);
		
		intent3 = new Intent(Intent.ACTION_SEND);
		
		Button phone = (Button) findViewById(R.id.contact_phone_number);
		Button email = (Button) findViewById(R.id.contact_email);
		TextView name = (TextView) findViewById(R.id.contact_name);
		TextView twitter = (TextView) findViewById(R.id.contact_twitter);
		
		Bundle extras = getIntent().getExtras();
		String user_name = extras.getString("user_name");
		
		ArrayList<User> uList = User.findByName(user_name);
		
		if(uList.size() > 0)
			u = uList.get(0);

		final String userPhoneNumber = (u != null) ? u.phone : "411";
		final String userName = (u != null) ? u.name : "N/A";
		final String userEmail = (u != null) ? u.email : "N/A";
		final String userTwitter = (u != null) ? u.twitter : "N/A";
		final ArrayList<Group> usersGroup = u.getLifelines();
		
		phone.setText("Call "+userPhoneNumber);
		email.setText(userEmail);
		name.setText("Name: "+ userName);
		twitter.setText("Twitter: " + userTwitter);
		
		final ArrayList<String> groupList = new ArrayList<String>();
		for(Group g: usersGroup)
			groupList.add(g.name);

		phone.setOnClickListener(new View.OnClickListener(){
			public void onClick(View v){
				String url = "tel: "+userPhoneNumber;
				intent = new Intent(Intent.ACTION_CALL, Uri.parse(url));
				startActivity(intent);
			}
		});

		email.setOnClickListener(new View.OnClickListener(){
			public void onClick(View v){
				intent3.setType("plain/text");
				intent3.putExtra(Intent.EXTRA_EMAIL, new String[] { userEmail });
				intent3.putExtra(Intent.EXTRA_SUBJECT, "subject");
				intent3.putExtra(Intent.EXTRA_TEXT, "mail body");
				startActivity(Intent.createChooser(intent3, ""));
			}
		});
		
		lv = (ListView) findViewById(R.id.contact_list);
		lv.setAdapter(new ArrayAdapter<String>(this,  android.R.layout.simple_list_item_1, groupList));

		lv.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				intent2 = new Intent(getApplicationContext(), LifeLines.class);// pass actual group id for LifeLines page to process
				intent2.putExtra("group_name", groupList.get(position));
				startActivity(intent2);
				Toast.makeText(getApplicationContext(), "Checkout the LifeLine..", Toast.LENGTH_SHORT).show();
			}
		});
	}
}
