package lifeline.ui;

import java.util.ArrayList;

import lifeline.model.Group;
import lifeline.model.User;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

public class InviteMember extends Activity {
	private ListView lv;
	//private Intent intent;
	private Group g = null;
	private ArrayList<String> listofusers = new ArrayList<String>();
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.invitemember);
        lv = (ListView) findViewById(R.id.addmember_list);
        
        Bundle extras = getIntent().getExtras();
		String group_name = extras.getString("group_name");
		
		g = Group.findByName(group_name).get(0);
        
        for(User u: User.all()) {
        	if (g != null && !g.isMember(u))
        		listofusers.add(u.name);
        }
        
		lv.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, listofusers));
		
		lv.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				ArrayList<User> tempU = User.findByName(listofusers.get(position));
				final User selectedUser = tempU.get(0);
				
				final String uName = selectedUser.name;
				if(selectedUser != null && g != null){
					final AlertDialog.Builder builder = new AlertDialog.Builder(InviteMember.this);
					builder.setMessage("Would you like to invite "+uName+"?")
					.setCancelable(false)
					.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) {
							g.addMember(selectedUser);
							Toast.makeText(getApplicationContext(), "User "+uName+" has been succesfully invited ...", 
									Toast.LENGTH_SHORT).show();
						}
					})
					.setNegativeButton("No", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) {
							dialog.cancel();
						}
					});
					
					AlertDialog alert = builder.create();
					alert.show();
				}
			}
		});
    }
}
