package lifeline.ui;

import java.util.ArrayList;

import lifeline.model.Account;
import lifeline.model.Group;
import lifeline.model.User;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class JoinLifelines extends Activity {
	private ListView lv;
	private User u = Account.currUser();
	private Group g = null;
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		lv = (ListView) findViewById(R.id.joinlifeline_list);
		
		ArrayList<Group> groupListTemp = Group.all();
		for(Group ggg: Group.all())
			if(ggg != null)
				groupListTemp.add(ggg);
		
		final ArrayList<Group> groupList = groupListTemp;
		String[] group_names = new String[groupList.size()];
		
		for(int i=0; i< groupList.size(); i++)
			if(groupList.get(i) != null)
				group_names[i] = groupList.get(i).name;
		
		lv.setAdapter(new ArrayAdapter<String>(getApplicationContext(), android.R.layout.simple_list_item_1, group_names));
		
		lv.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {				
				g = groupList.get(position);
				final String gName = g.name;
				
				if(u != null && g != null){
					final AlertDialog.Builder builder = new AlertDialog.Builder(JoinLifelines.this);
					builder.setMessage("Would you like to join "+gName+" ?")
					.setCancelable(false)
					.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) {
							g.addMember(u);
							Toast.makeText(getApplicationContext(), gName+" has been succesfully add to your Lifelines! ...", 
									Toast.LENGTH_SHORT).show();
						}
					})
					.setNegativeButton("No", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) {
							dialog.cancel();
						}
					});
					
					AlertDialog alert = builder.create();
					alert.show();
				}
			}
		});
		
	}
}
