package lifeline.ui;

import java.util.ArrayList;
import java.util.Collections;

import lifeline.model.Account;
import lifeline.model.Group;
import lifeline.model.Message;
//import lifeline.model.Message;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnFocusChangeListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class LifeLines extends Activity {
	private ListView lv;
	private Intent intent;
	private Intent intent2;
	private Group group;
	private ArrayList<String> list_of_msgs = new ArrayList<String>();
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.lifelines);

		Bundle extras = getIntent().getExtras();
		String group_name = extras.getString("group_name");
		group = Group.findByName(group_name).get(0);
		
		//set the title to group name
		((TextView) findViewById(R.id.lifeline_init)).setText(group_name);
		
		//populate messages list
		ArrayList<Message> messages = group.getMessages();
		Collections.reverse(messages);
		if(messages.size() > 0) {
			for (Message m : messages) {
				list_of_msgs.add(m.sender() + " - " +  m.text);
			}
		}
		
		lv = (ListView) findViewById(R.id.lifelines_list);
		refreshMessageList();
		
		EditText newMessageText = ((EditText) findViewById(R.id.lifelines_msg));
		newMessageText.setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				String str = ((EditText) findViewById(R.id.lifelines_msg)).getText().toString();
				if(str.equals("New message"))
					((EditText) findViewById(R.id.lifelines_msg)).setText("");
			}
		});
		
		Button sendMessageButton = ((Button) findViewById(R.id.lifelines_send));
		sendMessageButton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v){
				final ProgressDialog dialog = ProgressDialog.show(LifeLines.this, "Sending your Message","Please Wait ...", true);
				final Handler handler = new Handler() {
					public void handleMessage(android.os.Message msg) {
						dialog.dismiss();
						//((TextView) findViewById(R.id.lifeline_init)).setText("");
						//String x = msg.text;
						refreshMessageList();
						Toast.makeText(getApplicationContext(), "Add Message", Toast.LENGTH_SHORT).show();
					}
				};
				Thread p_thread = new Thread() {  
					public void run() {
						String message = ((EditText) findViewById(R.id.lifelines_msg)).getText().toString();
						group.addMessage(message, Account.currUser());
						list_of_msgs.add(0, Account.currUser().name + " says \"" +  message+ "\"");
						handler.sendEmptyMessage(0);
					}
				};
				p_thread.start();
			}
		});
	}

	private void refreshMessageList(){
		lv.setAdapter(null);
		lv.setAdapter(new ArrayAdapter<String>(this,  android.R.layout.simple_list_item_1, list_of_msgs));
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.options_lifelines, menu);
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.lifeline_menu_addmember:
			intent = new Intent(this, InviteMember.class);
			intent.putExtra("group_name", group.name);
			Toast.makeText(this, "Redirecting to Invite a Member", Toast.LENGTH_SHORT).show();
			startActivity(intent);
			return true;
		case R.id.lifeline_menu_viewmembers:
			Toast.makeText(this, "Viewing Members...", Toast.LENGTH_SHORT).show();
			intent2 = new Intent(this, ViewMembers.class);
			intent2.putExtra("group_name", group.name);
			startActivity(intent2);
			return true;
		case R.id.lifeline_menu_home: 
			Toast.makeText(this, "Goin Back Home... ", Toast.LENGTH_SHORT).show();
			startActivity(new Intent(this, Home.class));
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}
}