package lifeline.ui;

import lifeline.model.Account;
import lifeline.model.User;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnFocusChangeListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class Login extends Activity {
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.login);
        setEditTexts();
        
        Button create = (Button) findViewById(R.id.login_create_button);
        
        create.setOnClickListener(new View.OnClickListener() {
        	@Override
        	public void onClick(View v) {
        		final ProgressDialog dialog = ProgressDialog.show(Login.this, "Creating Account","Please Wait ...", true);
        		final Handler handler = new Handler() {
        			public void handleMessage(Message msg) {
        				dialog.dismiss();
        				Intent intentHome = new Intent(Login.this, Home.class);
        				startActivity(intentHome);
        			}
        		};
        		
        		Thread p_thread = new Thread() {  
        			public void run() {
        				String name = ((EditText) findViewById(R.id.login_name)).getText().toString();
        				String email = ((EditText) findViewById(R.id.login_email)).getText().toString();
        				String phone = ((EditText) findViewById(R.id.login_phonenumber)).getText().toString();
        				String twitter = ((EditText) findViewById(R.id.login_twitter)).getText().toString();
        				User newUser = new User(name, "1234", phone , email , twitter);
        				Account.authenticate(getApplicationContext(), newUser, "1234");

        				handler.sendEmptyMessage(0);
        			}
        		};
        		p_thread.start();
        	}
        });
    }
    
    private void setEditTexts(){
    	
        Toast.makeText(this, "Please Create A Local Account ...", Toast.LENGTH_LONG).show();
        
    	((EditText) findViewById(R.id.login_name)).setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				clearText((EditText) findViewById(R.id.login_name));
			}
		});

		((EditText) findViewById(R.id.login_email)).setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				clearText((EditText) findViewById(R.id.login_email));
			}
		});

		((EditText) findViewById(R.id.login_phonenumber)).setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				clearText((EditText) findViewById(R.id.login_phonenumber));
			}
		});
		
		((EditText) findViewById(R.id.login_twitter)).setOnFocusChangeListener(new OnFocusChangeListener() {
			public void onFocusChange(View v, boolean hasFocus) {
				clearText((EditText) findViewById(R.id.login_twitter));
			}
		});
    }
    
    private void clearText(EditText et){
		String str = et.getText().toString();
		if (str.equals("Name:") || str.equals("Email:") || str.equals("Twitter:") || str.equals("Phone:")){
			et.setText("");
		}
	}
}
