package lifeline.ui;

import java.util.ArrayList;

import lifeline.model.Group;
import lifeline.model.User;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;

public class ViewMembers extends Activity{
	private ListView lv;
	private Group g = null;
	private User u = null;
	private Intent intent;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.viewmembers);
        
        Bundle extras = getIntent().getExtras();
		String group_name = extras.getString("group_name");
        
        ArrayList<Group> gList = Group.findByName(group_name);
		ArrayList<String> name_list = new ArrayList<String>();
        
        lv = (ListView) findViewById(R.id.viewmember_list);
        
		if(gList.size() > 0)
			g = gList.get(0);
		
		final ArrayList<User> userList = g.getMembers();
		
		for(User u: userList)
			name_list.add(u.name);
		
		lv.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, name_list));
		
		((Button) findViewById(R.id.viewmembers_update)).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				lv.setAdapter(null);
				ArrayList<String> updateList = new ArrayList<String>();
				
				for(User u: g.getMembers())
					updateList.add(u.name);
				
				lv.setAdapter(new ArrayAdapter<String>(getApplicationContext(), 
						android.R.layout.simple_list_item_1, updateList));
			}
		});
		
		lv.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				final ArrayList<String> passList = new ArrayList<String>();
				for (User u: userList)
					passList.add(u.name);
				
				ArrayList<User> uList = User.findByName(passList.get(position));
				
				if (uList.size() > 0)
					u = uList.get(0);
				
				intent = new Intent(getApplicationContext(), Contact.class);
				if(u != null) intent.putExtra("user_name", u.name);
				
				startActivity(intent);
			}
		});
	}
}
